<script setup lang="ts">
    import { useRechercheGmaoActeur } from '@/interventionServiceOffer/composables/gmaoActeur/useRechercheGmaoActeur'
    import { interventionServiceOfferInjectionKey } from '@/interventionServiceOffer/constants'
    import { ActiviteActionApi } from '@/interventionServiceOffer/entities/activite/ActiviteActionApi'
    import { activiteActionMapper } from '@/interventionServiceOffer/entities/activite/ActiviteActionMapper'
    import { GmaoActeurApi } from '@/interventionServiceOffer/entities/gmaoActeur/GmaoActeurApi'
    import { Intervention } from '@/interventionServiceOffer/entities/intervention/Intervention'
    import { useMsal } from '@/plugins/msal/useMsal'
    import { getAnalyticsProvider } from '@/shared/analytics/AnalyticsProvider'
    import { RequestAborter } from '@/shared/api/entities/RequestAborter'
    import {
        serviceOfferIdInjectionKey,
        serviceOfferTrackingCategoryInjectionKey,
    } from '@/shared/constants'
    import { SilabError } from '@/shared/errors/SilabError'
    import { GmaoActeur } from '@/shared/gmaoActeur/GmaoActeur'
    import { removeDuplicateElementsWithId } from '@/shared/helpers/arrays'
    import { arrayContainsAllElements } from '@/shared/helpers/identifiable'
    import { useUserStore } from '@/shared/user/stores/UserStore'
    import {
        Ref,
        computed,
        ref,
        watch,
        onBeforeUnmount,
        WritableComputedRef,
        watchEffect,
        ComputedRef,
    } from 'vue'
    import {
        isDefined,
        isNull,
        isNullOrUndefined,
        isUndefined,
        requiredInject,
    } from '@/shared/helpers/types'
    import { ActiviteAction } from '@/interventionServiceOffer/entities/activite/ActiviteAction'
    import {
        getDateLocalIsoString,
        dateTimeToDateInputValue,
    } from '@/shared/helpers/dates'
    import { VolatileSecuredData } from '@/shared/helpers/lifeCycle'
    import { readonly } from 'vue'
    import { deepEquals } from '@/shared/helpers/objects'

    interface Props {
        intervention: Intervention
        loggedInGmaoActeur: GmaoActeur
    }
    const props = defineProps<Props>()

    const activitésActionOriginales = defineModel<
        VolatileSecuredData<ActiviteAction[]>
    >('activitésActionOriginales', {
        required: true,
    })
    const serviceOfferId = requiredInject(serviceOfferIdInjectionKey)
    const serviceOffer = requiredInject(interventionServiceOfferInjectionKey)
    const serviceOfferTrackingCategory = requiredInject(
        serviceOfferTrackingCategoryInjectionKey
    )

    const msal = useMsal()
    const userStore = useUserStore(msal)
    const activiteApi = new ActiviteActionApi(msal)
    const gmaoActeurApi = new GmaoActeurApi(msal)

    const intervenantsSelectionnées = ref<GmaoActeur[]>([
        props.loggedInGmaoActeur,
    ])

    const {
        resultatsRecherche: choixIntervenants,
        nomCompletRecherché: nomCompletIntervenantRecherché,
        isLoading: choixIntervenantsIsLoading,
    } = useRechercheGmaoActeur(msal)

    const equipiersDeLAgentConnecte: Ref<GmaoActeur[]> = ref([])
    const intervenantsSupplémentaires: Ref<GmaoActeur[]> = ref([])
    const intervenantsDisponibles = computed(() => {
        return removeDuplicateElementsWithId([
            props.loggedInGmaoActeur,
            ...props.intervention.intervenantsAffectes,
            ...intervenantsSupplémentaires.value,
        ])
    })

    const iLYADesAgentDeMonEquipeQuiPeuventÊtreRajoutésDansLesAgentsDisponibles =
        computed(() => {
            const lAgentPossedeDesÉquipiers =
                equipiersDeLAgentConnecte.value.length > 0
            const mesÉquipiersSontDéjàPrésents = arrayContainsAllElements(
                intervenantsDisponibles.value,
                equipiersDeLAgentConnecte.value
            )
            return lAgentPossedeDesÉquipiers && !mesÉquipiersSontDéjàPrésents
        })

    const isIntervenantsDisponibleLoading = ref<boolean>(true)

    const equipiersDeLAgentConnecteFetchAborter = new RequestAborter()
    watch(
        [() => msal.accounts, () => userStore.isImpersonating],
        () => {
            isIntervenantsDisponibleLoading.value = true
            equipiersDeLAgentConnecteFetchAborter.abortRequestsAndRefreshAborter()
            gmaoActeurApi
                .getTeammates(
                    serviceOfferId.value,
                    equipiersDeLAgentConnecteFetchAborter.getSignal()
                )
                .then((teammates) => {
                    equipiersDeLAgentConnecte.value = teammates
                })
                .catch((error) => {
                    if (error.name !== 'AbortError') {
                        throw new SilabError((<Error>error).message, 'error')
                    }
                })
                .finally(() => {
                    isIntervenantsDisponibleLoading.value = false
                })
        },
        { immediate: true }
    )
    onBeforeUnmount(() => {
        equipiersDeLAgentConnecteFetchAborter.abortRequests()
    })

    const maxMinutes = 59
    const rules = {
        areValidHours: (inputHours: number) => {
            return inputHours >= 0 || 'Veuillez saisir une valeur positive'
        },
        areValidMinutes: (inputMinutes: number) => {
            return (
                (inputMinutes >= 0 && inputMinutes <= maxMinutes) ||
                `Veuillez saisir une valeur comprise entre 0 et ${maxMinutes} inclus`
            )
        },
        hasDurationWhenIntervenantSelected: () => {
            if (intervenantsSelectionnées.value.length === 0) {
                return true
            }
            return (
                duréeTotaleEnMinutes.value > 0 ||
                'La saisie du temps passé des intervenants sélectionnés est obligatoire'
            )
        },
        hasIntervenantWhenDurationSelected: () => {
            if (duréeTotaleEnMinutes.value === 0) {
                return true
            }
            return (
                intervenantsSelectionnées.value.length > 0 ||
                'Vous devez choisir des intervenants pour renseigner un temps passé'
            )
        },
        dateDeDébutInputIsInPast: (date: string | undefined | null) => {
            if (isNullOrUndefined(date)) return true
            return (
                new Date(date).getTime() < Date.now() ||
                'La date de début renseignée doit être dans le passé'
            )
        },
        dateDeDébutInputIsDefined: (date: string | undefined | null) => {
            if (isNullOrUndefined(date)) {
                return 'Veuillez selectionner une date de début'
            }
            return true
        },
    }
    const formIsValid = ref<boolean>()

    const activitésCompletés = computed(() => {
        return (
            formIsValid.value === true &&
            rules.hasDurationWhenIntervenantSelected() === true
        )
    })

    const dateDeDébutParDefaut = ref<Date | undefined>()

    watchEffect(() => {
        const targetDateDeDébut = new Date().setHours(
            0,
            serviceOffer.value?.data?.configurationFormulaireActivite
                .heureParDefautEnMinute,
            0,
            0
        )

        dateDeDébutParDefaut.value = new Date(
            Math.min(targetDateDeDébut, Date.now()) //on s'assure que la date générée avec l'heure par défaut ne se trouve pas dans le futur
        )
    })

    const attributsCommunsAuxActivités: Ref<Partial<ActiviteAction>> = ref({})

    function defaultAttributsCommunsAuxActivités() {
        return {
            dateDeDebut: dateDeDébutParDefaut.value,
            duree: 0,
            operation: undefined,
        }
    }

    function resetAttributsCommunsAuxActivité() {
        attributsCommunsAuxActivités.value =
            defaultAttributsCommunsAuxActivités()
    }
    resetAttributsCommunsAuxActivité()

    const minutesRenseignées: WritableComputedRef<number> = computed({
        get: () => {
            return (attributsCommunsAuxActivités.value.duree ?? 0) % 60
        },
        set: (minutes: number) => {
            attributsCommunsAuxActivités.value.duree =
                heuresRenseignées.value * 60 + minutes
        },
    })
    const heuresRenseignées: WritableComputedRef<number> = computed({
        get: () => {
            return Math.floor(
                (attributsCommunsAuxActivités.value.duree ?? 0) / 60
            )
        },
        set: (heures: number) => {
            attributsCommunsAuxActivités.value.duree =
                heures * 60 + minutesRenseignées.value
        },
    })

    const dateDeDébutInputDatetime: WritableComputedRef<
        string | undefined | null
    > = computed({
        get() {
            return isNullOrUndefined(
                attributsCommunsAuxActivités.value.dateDeDebut
            )
                ? undefined
                : dateTimeToDateInputValue(
                      attributsCommunsAuxActivités.value.dateDeDebut
                  )
        },
        set(date: string | undefined) {
            attributsCommunsAuxActivités.value.dateDeDebut = isNullOrUndefined(
                date
            )
                ? undefined
                : new Date(date)
        },
    })

    const dateDeDébutInputDate: WritableComputedRef<string | undefined | null> =
        computed({
            get() {
                return isNullOrUndefined(
                    attributsCommunsAuxActivités.value.dateDeDebut
                )
                    ? undefined
                    : getDateLocalIsoString(
                          attributsCommunsAuxActivités.value.dateDeDebut
                      )
            },
            set(date: string | undefined | null) {
                if (
                    isUndefined(
                        serviceOffer.value?.data
                            ?.configurationFormulaireActivite
                            .heureParDefautEnMinute
                    )
                ) {
                    return
                }
                if (isNullOrUndefined(date)) {
                    attributsCommunsAuxActivités.value.dateDeDebut = undefined
                    return
                }
                const targetDateDeDébut = new Date(date).setHours(
                    0,
                    serviceOffer.value.data.configurationFormulaireActivite
                        .heureParDefautEnMinute,
                    0,
                    0
                )
                attributsCommunsAuxActivités.value.dateDeDebut = new Date(
                    Math.min(targetDateDeDébut, Date.now()) //on s'assure que la date générée avec l'heure par défaut ne se trouve pas dans le futur
                )
            },
        })

    const duréeTotaleEnMinutes = computed(() => {
        return minutesRenseignées.value + heuresRenseignées.value * 60
    })

    watchEffect(() => {
        if (
            serviceOffer.value?.data?.configurationFormulaireActivite
                .dateDeDebut !== 'automatique'
        ) {
            return
        }
        attributsCommunsAuxActivités.value.dateDeDebut = new Date(
            Date.now() - duréeTotaleEnMinutes.value * 60 * 1000
        )
    })

    const activitésACréer: ComputedRef<Partial<ActiviteAction>[]> = computed(
        () => {
            return intervenantsSelectionnées.value.map((intervenant) => {
                return {
                    ...attributsCommunsAuxActivités.value,
                    intervenant: intervenant,
                }
            })
        }
    )
    async function déclarerActivités() {
        const interventionId = props.intervention.id
        try {
            await Promise.all(
                activitésACréer.value.map(async (activitéACréer) => {
                    const activitéActionCréée = await activiteApi.create(
                        activiteActionMapper.toCreateDto(activitéACréer),
                        serviceOfferId.value,
                        interventionId
                    )
                    if (isDefined(activitésActionOriginales.value?.data)) {
                        activitésActionOriginales.value.data.push(
                            activitéActionCréée
                        )
                    }
                })
            )
        } catch (error) {
            throw new SilabError(
                `Erreur lors de la déclaration des activités pour l'intervention ${props.intervention.title}`,
                error
            )
        }
        getAnalyticsProvider().sendEvent(
            serviceOfferTrackingCategory.value,
            'Déclaration activités',
            props.intervention.code,
            intervenantsSelectionnées.value.length
        )
    }

    const isDirty = computed(() => {
        return !deepEquals(
            attributsCommunsAuxActivités.value,
            defaultAttributsCommunsAuxActivités()
        )
    })

    defineExpose({
        déclarerActivités,
        resetAttributsCommunsAuxActivité,
        activitésCompletés,
        isDirty: readonly(isDirty),
    })

    function ajouterIntervenantSupplémentaire(
        nouvelIntervenant: GmaoActeur | null
    ): void {
        if (isNull(nouvelIntervenant)) {
            return
        }
        if (
            !intervenantsDisponibles.value.some(
                (intervenant) => intervenant.id === nouvelIntervenant.id
            )
        ) {
            intervenantsSupplémentaires.value.push(nouvelIntervenant)
        }
        if (
            !intervenantsSelectionnées.value.some(
                (intervenant) => intervenant.id === nouvelIntervenant.id
            )
        ) {
            intervenantsSelectionnées.value.push(nouvelIntervenant)
        }
    }
</script>

<template>
    <div class="mt-3">
        <h3>Intervenants</h3>
        <v-skeleton-loader
            v-if="isIntervenantsDisponibleLoading"
            type="list-item,list-item ,list-item"
        />
        <div v-else class="position-relative">
            <p
                v-if="rules.hasIntervenantWhenDurationSelected() !== true"
                class="text-caption text-error position-absolute"
                style="top: -4px"
            >
                {{ rules.hasIntervenantWhenDurationSelected() }}
            </p>
            <template
                v-for="intervenant in intervenantsDisponibles"
                :key="intervenant.id"
            >
                <v-switch
                    v-model="intervenantsSelectionnées"
                    :label="intervenant.nomComplet"
                    :value="intervenant"
                    color="primary"
                    :data-cy="'intervenant-disponible-' + intervenant.id"
                    hide-details
                />
            </template>
            <a
                v-if="
                    iLYADesAgentDeMonEquipeQuiPeuventÊtreRajoutésDansLesAgentsDisponibles
                "
                variant="plain"
                class="d-inline-block mb-3 ms-2 cursor-pointer"
                @click="
                    intervenantsSupplémentaires.push(
                        ...equipiersDeLAgentConnecte
                    )
                "
            >
                <v-icon class="me-4">mdi-account-multiple-plus-outline</v-icon>
                Ajouter mes équipiers
            </a>
            <v-autocomplete
                v-model:search="nomCompletIntervenantRecherché"
                label="Ajouter un intervenant supplémentaire"
                placeholder="Rechercher un intervenant"
                data-cy="select-intervenant"
                item-title="nomComplet"
                prepend-inner-icon="mdi-account-search-outline"
                clearable
                return-object
                hide-no-data
                :items="choixIntervenants"
                :loading="choixIntervenantsIsLoading"
                @update:model-value="
                    (nouvelIntervenant) => {
                        ajouterIntervenantSupplémentaire(nouvelIntervenant)
                    }
                "
            />
        </div>
        <h3>Opération</h3>
        <v-autocomplete
            v-model="attributsCommunsAuxActivités.operation"
            :items="
                loggedInGmaoActeur.getOpérationsHabiliteesTriéesParOrdreAlphabétique()
            "
            class="mt-3"
            return-object
            data-cy="select-operation"
            item-title="label"
            label="Sélectionner une opération"
            placeholder="Rechercher une opération"
            no-data-text="Aucune opération accessible, vérifiez vos droits"
        />
        <h3>Temps passé</h3>
        <v-form v-model="formIsValid" class="mt-0">
            <div>
                <p
                    v-if="rules.hasDurationWhenIntervenantSelected() !== true"
                    class="text-caption text-error"
                >
                    {{ rules.hasDurationWhenIntervenantSelected() }}
                </p>
            </div>
            <div class="d-flex">
                <v-text-field
                    v-model.number="heuresRenseignées"
                    label="Heures"
                    type="number"
                    min="0"
                    :rules="[rules.areValidHours]"
                    data-cy="hours-spend-input"
                />
                &nbsp;
                <v-text-field
                    v-model.number="minutesRenseignées"
                    label="Minutes"
                    type="number"
                    :rules="[rules.areValidMinutes]"
                    :max="maxMinutes"
                    min="0"
                    data-cy="minutes-spend-input"
                />
            </div>
            <v-slider
                v-model.number="heuresRenseignées"
                :min="0"
                :max="8"
                step="1"
                color="primary"
                track-color="grey"
                label="Heures"
                data-cy="hours-spend-slider"
            />
            <v-slider
                v-model.number="minutesRenseignées"
                :min="0"
                :max="55"
                step="5"
                color="primary"
                track-color="grey"
                label="Minutes"
                data-cy="minutes-spend-slider"
            />
            <v-text-field
                v-if="
                    serviceOffer?.data?.configurationFormulaireActivite
                        .dateDeDebut === 'heure'
                "
                v-model="dateDeDébutInputDatetime"
                :rules="[
                    rules.dateDeDébutInputIsDefined,
                    rules.dateDeDébutInputIsInPast,
                ]"
                label="Début"
                type="datetime-local"
                :max="dateTimeToDateInputValue(new Date())"
                data-cy="date-de-début-input-datetime"
            >
            </v-text-field>
            <v-text-field
                v-if="
                    serviceOffer?.data?.configurationFormulaireActivite
                        .dateDeDebut === 'jour'
                "
                v-model="dateDeDébutInputDate"
                label="Début"
                type="date"
                :rules="[
                    rules.dateDeDébutInputIsDefined,
                    rules.dateDeDébutInputIsInPast,
                ]"
                :max="getDateLocalIsoString(new Date())"
                data-cy="date-de-début-input-date"
            >
            </v-text-field>
        </v-form>
    </div>
</template>
